/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package classesUnion;

import data.Attribute;
import data.Example;
import dbrsaaorc.params.Latex;
import dominanceCone.PositiveDominanceCone;
import java.util.List;

/**
 *
 * @author Mateusz Ledzianowski
 */
public class LowerApproxOfPositiveClassesUnion extends ClassesUnion {

    /**
     * Basic constructor of the lower approximation of positive classes union
     *
     * @param decisionAttribute
     * @param attributeValue
     * @param examples
     */
    public LowerApproxOfPositiveClassesUnion(Attribute decisionAttribute,
            String attributeValue, List<Example> examples) {
        super(decisionAttribute, attributeValue);
        calculateClassesUnion(examples);
    }

    /**
     * Function calculates a lower approximation of classes union from the given
     * list of examples.
     *
     * @param examples
     */
    @Override
    protected final void calculateClassesUnion(List<Example> examples) {
        PositiveClassesUnion pcu = new PositiveClassesUnion(
                getDecisionAttribute(), getDecisionValue(), examples);
        for (Example ex : examples) {
            PositiveDominanceCone pdc = new PositiveDominanceCone(ex, examples);
            if (pdc.in(pcu)) {
                add(ex);
            }
        }
    }

    /**
     * @return string representation of the object
     */
    @Override
    public String toString(Latex latex) {
        if (latex != Latex.NONE) {
            return super.toString(latex);
        } else {
            return String.format("P_(C>=%s) = %s", getDecisionValue(), super.toString(latex));
        }
    }

    /**
     * @return string representation of the object
     */
    @Override
    public String toString() {
        return toString(Latex.NONE);
    }
}
