/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package classesUnion;

import data.Attribute;
import data.Example;
import java.util.List;

/**
 *
 * @author Mateusz Ledzianowski
 */
public class PositiveClassesUnion extends ClassesUnion {

    /**
     * Basic constructor of the positive classes union
     *
     * @param decisionAttribute
     * @param attributeValue
     * @param examples
     */
    public PositiveClassesUnion(Attribute decisionAttribute,
            String attributeValue, List<Example> examples) {
        super(decisionAttribute, attributeValue);
        calculateClassesUnion(examples);
    }

    /**
     * Function calculates a classes union from the given list
     * of examples.
     *
     * @param examples
     */
    @Override
    protected final void calculateClassesUnion(List<Example> examples) {
        for (Example ex : examples) {
            Integer cmp = getDecisionAttribute()
                    .compareValues(ex.getDecisionValue(), getDecisionValue());
            if (cmp >= 0) {
                add(ex);
            }
        }
    }
}
