/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package classesUnion;

import data.Attribute;
import data.Example;
import dbrsaaorc.params.Latex;
import dominanceCone.NegativeDominanceCone;
import java.util.List;

/**
 *
 * @author Mateusz Ledzianowski
 */
public class UpperApproxOfNegativeClassesUnion extends ClassesUnion {

    /**
     * Basic constructor of the upper appriximation of negative classes union
     *
     * @param decisionAttribute
     * @param attributeValue
     * @param examples
     */
    public UpperApproxOfNegativeClassesUnion(Attribute decisionAttribute,
            String attributeValue, List<Example> examples) {
        super(decisionAttribute, attributeValue);
        calculateClassesUnion(examples);
    }

    /**
     * Function calculates a classes union from the given list of examples.
     *
     * @param examples
     */
    @Override
    protected final void calculateClassesUnion(List<Example> examples) {
        NegativeClassesUnion pcu = new NegativeClassesUnion(
                getDecisionAttribute(), getDecisionValue(), examples);
        for (Example ex : pcu) {
            NegativeDominanceCone pdc = new NegativeDominanceCone(ex, examples);
            for (Example ex2 : pdc) {
                add(ex2);
            }
        }
    }

    /**
     * @return string representation of the object
     */
    @Override
    public String toString(Latex latex) {
        if (latex != Latex.NONE) {
            return super.toString(latex);
        } else {
            return String.format("P^(C<=%s) = %s", getDecisionValue(), super.toString(latex));
        }
    }

    /**
     * @return string representation of the object
     */
    @Override
    public String toString() {
        return toString(Latex.NONE);
    }
}
