/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package coalition;

import classesUnion.ClassesUnion;
import data.Attribute;
import java.util.List;
import java.util.Map;

/**
 *
 * @author Mateusz Ledzianowski
 */
public class MinimumSufficientCoalitions extends SufficientCoalitions {

    /**
     * Basic constructor of the minumum sufficient coalitions
     *
     * @param aopcu
     * @param aoncu
     * @param mics
     * @param allAttributes
     */
    public MinimumSufficientCoalitions(ClassesUnion aopcu,
            ClassesUnion aoncu,
            MaximumInsufficientCoalitions mics,
            List<Attribute> allAttributes) {
        super(aopcu, aoncu);
        if (mics != null) {
            removeCoveredCoalitions(mics, allAttributes);
        }
        calculateMinimumCoalitions();
    }

    /**
     * Basic constructor of the minumum sufficient coalitions
     *
     * @param approxOfPositiveClassesUnions
     * @param approxOfNegativeClassesUnions
     * @param mics
     * @param allAttributes
     */
    public MinimumSufficientCoalitions(
            Map<String, ClassesUnion> approxOfPositiveClassesUnions,
            Map<String, ClassesUnion> approxOfNegativeClassesUnions,
            MaximumInsufficientCoalitions mics,
            List<Attribute> allAttributes) {
        super(approxOfPositiveClassesUnions,
                approxOfNegativeClassesUnions);
        if (mics != null) {
            removeCoveredCoalitions(mics, allAttributes);
        }
        calculateMinimumCoalitions();
    }

    /**
     * Basic constructor of the minumum sufficient coalitions
     *
     * @param sc
     * @param mics
     * @param allAttributes
     */
    public MinimumSufficientCoalitions(
            SetOfCoalitions sc,
            MaximumInsufficientCoalitions mics,
            List<Attribute> allAttributes) {
        super(sc);
        if (mics != null) {
            removeCoveredCoalitions(mics, allAttributes);
        }
        calculateMinimumCoalitions();
    }
}
