/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package coalition;

import classesUnion.ClassesUnion;
import data.Attribute;
import data.Example;
import java.util.Map;

/**
 *
 * @author Mateusz Ledzianowski
 */
public class SufficientCoalitions extends SetOfCoalitions {

    /**
     * Basic constructor of the sufficient coalitions
     *
     * @param aopcu
     * @param aoncu
     */
    public SufficientCoalitions(ClassesUnion aopcu,
            ClassesUnion aoncu) {
        super();
        calculateSufficientCoalitions(aopcu, aoncu);
    }

    /**
     * Basic constructor of the sufficient coalitions
     *
     * @param approxOfPositiveClassesUnions
     * @param approxOfNegativeClassesUnions
     */
    public SufficientCoalitions(
            Map<String, ClassesUnion> approxOfPositiveClassesUnions,
            Map<String, ClassesUnion> approxOfNegativeClassesUnions) {
        super();
        Attribute decisionAttribute = approxOfPositiveClassesUnions
                .values().stream().findFirst().orElse(null).getDecisionAttribute();
        if (decisionAttribute == null) {
            decisionAttribute = approxOfNegativeClassesUnions
                    .values().stream().findFirst().orElse(null).getDecisionAttribute();
        }
        for (int i = 0; i < decisionAttribute.getValues().size() - 1; ++i) {
            calculateSufficientCoalitions(
                    approxOfPositiveClassesUnions.get(
                            decisionAttribute.getValues().get(i + 1)),
                    approxOfNegativeClassesUnions.get(
                            decisionAttribute.getValues().get(i)));
        }
    }

    /**
     * Basic constructor of the sufficient coalitions
     *
     * @param sc
     */
    public SufficientCoalitions(SetOfCoalitions sc) {
        super(sc);
    }

    /**
     * Function calculates sufficient coalitions of criteria.
     *
     * @param aopcu
     * @param aoncu
     */
    public final void calculateSufficientCoalitions(
            ClassesUnion aopcu,
            ClassesUnion aoncu) {
        for (Example exU : aopcu) {
            for (Example exL : aoncu) {
                Coalition coalition = new Coalition(exU, exL);
                this.add(coalition);
                //System.out.println("(" + exU + ") vs (" + exL + "): " + coalition.toString());
            }
        }
    }
}
