/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package core;

import data.Example;
import dbrsaaorc.params.Latex;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;

/**
 *
 * @author Mateusz Ledzianowski
 */
public class SetOfExamples extends HashSet<Example> implements Comparable<SetOfExamples> {

    public SetOfExamples() {
        super();
    }

    public SetOfExamples(List<Example> examples) {
        super(examples);
    }

    public SetOfExamples(SetOfExamples o) {
        super(new HashSet<Example>(o));
    }

    /**
     * Function compares two objects
     *
     * @param o other object
     * @return the value 0 if this is equal to @param o; a value less than 0 if
     * this is less than @param o; a value greater than 0 if this is greater
     * than @param o
     */
    @Override
    public int compareTo(SetOfExamples o) {
        int cmp = Integer.valueOf(size()).compareTo(o.size());
        if (cmp == 0) {
            List<Example> myExamples = new ArrayList<>(this);
            List<Example> otherExamples = new ArrayList<>(o);
            Collections.sort(myExamples);
            Collections.sort(otherExamples);
            int n = myExamples.size();
            for (int i = 0; i < n; ++i) {
                cmp = myExamples.get(i).compareTo(otherExamples.get(i));
                if (cmp != 0) {
                    return cmp;
                }
            }
            return 0;
        } else {
            return cmp;
        }
    }

    /**
     * @param latex
     * @return string representation of the object
     */
    public String toString(Latex latex) {
        StringBuilder sb = new StringBuilder();
        if (latex == Latex.NONE) {
            sb.append("{");
        }
        List<Example> ExamplexList = new ArrayList<>(this);
        Collections.sort(ExamplexList);
        for (Example ex : ExamplexList) {
            sb.append(ex.toShortString(latex));
            if (latex != Latex.NONE) {
                sb.append(",\\allowbreak ");
            } else {
                sb.append(", ");
            }
        }
        if (!ExamplexList.isEmpty()) {
            if (latex != Latex.NONE) {
                sb.delete(sb.length() - 13, sb.length());
            } else {
                sb.delete(sb.length() - 2, sb.length());
            }
        }
        if (latex == Latex.NONE) {
            sb.append("}");
        }
        return sb.toString();
    }

    /**
     * @return string representation of the object
     */
    @Override
    public String toString() {
        return toString(Latex.NONE);
    }

    /**
     * @param o other object
     * @return true if SetOfExamples is in SetOfExamples o, false otherwise
     */
    public boolean in(SetOfExamples o) {
        for (Example ex : this) {
            if (!o.contains(ex)) {
                return false;
            }
        }
        return true;
    }
}
