/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package data;

/**
 * Attribute preference enum class
 *
 * @author Mateusz Ledzianowski
 */
public enum AttributePreference {
    GAIN,COST;

    /**
     * @param str with preference of attribute in isf format
     * @return attribute preference according to the given string
     */
    public static AttributePreference getAttributePreference(String str) throws RuntimeException {
        switch (str.toLowerCase()) {
            case "gain":
                return GAIN;
            case "cost":
                return COST;
            default:
                throw new IllegalArgumentException("Unknown attribute preference");
        }
    }
    
    @Override
    public String toString() {
        switch (this) {
            case GAIN:
                return "gain";
            case COST:
                return "cost";
            default:
                return "";
        }
    }
}
