/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package data;

/**
 * Attribute type enum class
 *
 * @author Mateusz Ledzianowski
 */
public enum AttributeType {
    CONTINUOUS, NUMBERCODED, OMIT, ORDEREDLIST, UNORDEREDLIST;

    /**
     * @param str with type of attribute in isf format
     * @return attribute type according to the given string
     */
    public static AttributeType getAttributeType(String str) throws RuntimeException {
        switch (str.charAt(0)) {
            case '[':
                return ORDEREDLIST;
            case '<':
                return ORDEREDLIST;
            case '(':
                switch (str) {
                    case "(continuous)":
                        return CONTINUOUS;
                    case "(numbercoded)":
                        return NUMBERCODED;
                    case "(integer)":
                        return NUMBERCODED;
                    case "(omit)":
                    case "(omitt)":
                        return OMIT;
                    default:
                        throw new IllegalArgumentException("Unknown attribute type");
                }
            default:
                throw new IllegalArgumentException("Wrong attribute type format");
        }
    }
}
