/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package dominanceCone;

import coalition.Coalition;
import data.Example;
import java.util.List;

/**
 *
 * @author Mateusz Ledzianowski
 */
public class PositiveDominanceCone extends DominanceCone {

    /**
     * Basic constructor of the positive dominance cone
     *
     * @param mainExample
     * @param examples
     */
    public PositiveDominanceCone(Example mainExample, List<Example> examples) {
        super(mainExample);
        calculateDominanceCone(examples);
    }

    /**
     * Function calculates positive dominance cone examples from the given list
     * of examples.
     *
     * @param examples
     */
    @Override
    protected final void calculateDominanceCone(List<Example> examples) {
        int nAttributes = getMainExample().getSufficientSize();
        for (Example ex : examples) {
            Coalition coalition = new Coalition(ex, getMainExample());
            if (coalition.size() == nAttributes) {
                add(ex);
            }
        }
    }
}
