/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package domlem;

import classesUnion.ClassesUnion;
import core.SetOfExamples;
import data.Attribute;
import data.Example;
import static domlem.ConditionScore.getCertainty;
import static domlem.ConditionScore.getCoverage;
import static domlem.ConditionScore.getStrength;

/**
 *
 * @author Mateusz Ledzianowski
 */
public class ConditionUnionScore extends ConditionScore {

    public ConditionUnionScore() {
    }

    public ConditionUnionScore(int support, float strength, float certainty, float coverage) {
        super(support, strength, certainty, coverage);
    }

    public ConditionUnionScore(Condition cond, ClassesUnion classesUnion, SetOfExamples examples) {
        super();
        Attribute decision = classesUnion.getDecisionAttribute();
        String decisionValue = classesUnion.getDecisionValue();
        int _support = 0;
        int _nAllExamples = 0;
        int _nInClassesUnion = 0;
        int _nSatisfiesCondition = 0;
        for (Example ex : examples) {
            ++_nAllExamples;
            if (classesUnion.contains(ex)) {
                ++_nInClassesUnion;
            }
            if (!cond.isFulfilled(ex)) {
                ++_nSatisfiesCondition;
                if (classesUnion.contains(ex)) {
                    ++_support;
                }
            }
        }

        float _strength = getStrength(_support, _nAllExamples);
        float _certainty = getCertainty(_support, _nSatisfiesCondition);
        float _coverage = getCoverage(_support, _nInClassesUnion);

        super.setSupport(_support);
        super.setStrength(_strength);
        super.setCertainty(_certainty);
        super.setCoverage(_coverage);
    }
}
