/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package domlem;

import core.SetOfExamples;
import data.Example;

/**
 *
 * @author Mateusz Ledzianowski
 */
public class RuleScore extends ConditionScore {

    public RuleScore() {
        super();
    }

    public RuleScore(int support, float strength, float certainty, float coverage) {
        super(support, strength, certainty, coverage);
    }

    public RuleScore(Rule rule, SetOfExamples examples) {
        super();
        Decision decision = rule.getDecision();
        int _support = 0;
        int _nAllExamples = 0;
        int _nSatisfiesDecision = 0;
        int _nSatisfiesCondition = 0;
        for (Example ex : examples) {
            ++_nAllExamples;
            if (decision.isFulfilled(ex)) {
                ++_nSatisfiesDecision;
            }
            boolean satisfiesCondition = true;
            for (Condition cond : rule.getConditions()) {
                if (!cond.isFulfilled(ex)) {
                    satisfiesCondition = false;
                }
            }
            if (satisfiesCondition) {
                examplesInCondition.add(ex);
                ++_nSatisfiesCondition;
                if (decision.isFulfilled(ex)) {
                    examplesInConditionAndDecision.add(ex);
                    ++_support;
                } else {
                    examplesInConditionAndNotDecision.add(ex);
                }
            }
        }

        float _strength = getStrength(_support, _nAllExamples);
        float _certainty = getCertainty(_support, _nSatisfiesCondition);
        float _coverage = getCoverage(_support, _nSatisfiesDecision);

        super.setSupport(_support);
        super.setStrength(_strength);
        super.setCertainty(_certainty);
        super.setCoverage(_coverage);
    }
}
