/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package domlem;

import core.SetOfExamples;
import data.Example;
import static domlem.ConditionScore.getCertainty;
import static domlem.ConditionScore.getCoverage;
import static domlem.ConditionScore.getStrength;

/**
 *
 * @author Mateusz Ledzianowski
 */
class RuleUnionScore extends RuleScore {

    public RuleUnionScore() {
        super();
    }

    public RuleUnionScore(int support, float strength, float certainty, float coverage) {
        super(support, strength, certainty, coverage);
    }

    public RuleUnionScore(Rule rule, SetOfExamples examplesToCover, SetOfExamples examples) {
        super();
        int _support = 0;
        int _nAllExamples = 0;
        int _nInClassesUnion = 0;
        int _nSatisfiesCondition = 0;
        for (Example ex : examples) {
            ++_nAllExamples;
            if (examplesToCover.contains(ex)) {
                ++_nInClassesUnion;
            }
            boolean satisfiesCondition = true;
            for (Condition cond : rule.getConditions()) {
                if (!cond.isFulfilled(ex)) {
                    satisfiesCondition = false;
                }
            }
            if (satisfiesCondition) {
                examplesInCondition.add(ex);
                ++_nSatisfiesCondition;
                if (examplesToCover.contains(ex)) {
                    examplesInConditionAndDecision.add(ex);
                    ++_support;
                } else {
                    examplesInConditionAndNotDecision.add(ex);
                }
            }
        }

        float _strength = getStrength(_support, _nAllExamples);
        float _certainty = getCertainty(_support, _nSatisfiesCondition);
        float _coverage = getCoverage(_support, _nInClassesUnion);

        super.setSupport(_support);
        super.setStrength(_strength);
        super.setCertainty(_certainty);
        super.setCoverage(_coverage);
    }
}
