/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package gui;

import data.Attribute;
import data.AttributeType;
import data.Example;
import data.ISF;
import dbrsaaorc.Classifier;
import dbrsaaorc.ClassifierNew;
import dbrsaaorc.ClassifierStandard;
import dbrsaaorc.Solver;
import dbrsaaorc.SolverResult;
import dbrsaaorc.params.Classification;
import dbrsaaorc.params.Coalitions;
import dbrsaaorc.params.Induction;
import dbrsaaorc.params.Latex;
import dbrsaaorc.params.Outranking;
import dbrsaaorc.params.RuleCoalitions;
import domlem.ListOfRules;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFileChooser;
import javax.swing.JTable;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.table.DefaultTableModel;

/**
 *
 * @author Mateusz Ledzianowski
 */
public class DbrsaaorcJFrame extends javax.swing.JFrame implements Runnable {

    private ISF dbModel;
    private ISF dbClassification;
    private SolverResult sr;

    /**
     * Creates new form DbrsaaorcJFrame
     */
    public DbrsaaorcJFrame() {
        initComponents();
        buttonGroupSettingsOutranking.add(jRadioButtonSettingsOutrankingIndividual);
        jRadioButtonSettingsOutrankingIndividual.setSelected(true);
        buttonGroupSettingsOutranking.add(jRadioButtonSettingsOutrankingAll);
        buttonGroupSettingsCoalitions.add(jRadioButtonSettingsCoalitionsNonOutranking);
        jRadioButtonSettingsCoalitionsNonOutranking.setSelected(true);
        buttonGroupSettingsCoalitions.add(jRadioButtonSettingsCoalitionsPreference);
        buttonGroupSettingsRuleCoalitions.add(jRadioButtonSettingsRuleCoalitionsFirst);
        jRadioButtonSettingsRuleCoalitionsFirst.setSelected(true);
        buttonGroupSettingsRuleCoalitions.add(jRadioButtonSettingsRuleCoalitionsRandom);
        buttonGroupSettingsRuleCoalitions.add(jRadioButtonSettingsRuleCoalitionsAll);
        buttonGroupSettingsInduction.add(jRadioButtonSettingsInductionPossible);
        jRadioButtonSettingsInductionPossible.setSelected(true);
        buttonGroupSettingsInduction.add(jRadioButtonSettingsInductionCertain);
        buttonGroupSettingsClassification.add(jRadioButtonSettingsClassificationStandard);
        jRadioButtonSettingsClassificationStandard.setSelected(true);
        buttonGroupSettingsClassification.add(jRadioButtonSettingsClassificationNew);
        buttonGroupSettingsClassification2.add(jRadioButtonSettingsClassificationStandard2);
        jRadioButtonSettingsClassificationStandard2.setSelected(true);
        buttonGroupSettingsClassification2.add(jRadioButtonSettingsClassificationNew2);

        initTableAttributes(new ArrayList<>());
        initTableExamples(new ArrayList<>(), new ArrayList<>());
        logMessage("Program has been started...");
        logMessage("Choose a file to calculate");
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroupSettingsOutranking = new javax.swing.ButtonGroup();
        buttonGroupSettingsCoalitions = new javax.swing.ButtonGroup();
        buttonGroupSettingsInduction = new javax.swing.ButtonGroup();
        buttonGroupSettingsClassification = new javax.swing.ButtonGroup();
        buttonGroupSettingsClassification2 = new javax.swing.ButtonGroup();
        buttonGroupSettingsRuleCoalitions = new javax.swing.ButtonGroup();
        jTabbedPaneExamples = new javax.swing.JTabbedPane();
        jPanelInput = new javax.swing.JPanel();
        jButtonOpenFile = new javax.swing.JButton();
        jScrollPaneLogs = new javax.swing.JScrollPane();
        jTextAreaLogs = new javax.swing.JTextArea();
        jPanelSettings = new javax.swing.JPanel();
        jLabelSettings = new javax.swing.JLabel();
        jLabelSettingsOutranking = new javax.swing.JLabel();
        jRadioButtonSettingsOutrankingAll = new javax.swing.JRadioButton();
        jRadioButtonSettingsOutrankingIndividual = new javax.swing.JRadioButton();
        jLabelSettingsCoalitions = new javax.swing.JLabel();
        jRadioButtonSettingsCoalitionsNonOutranking = new javax.swing.JRadioButton();
        jRadioButtonSettingsCoalitionsPreference = new javax.swing.JRadioButton();
        jLabelSettingsInduction = new javax.swing.JLabel();
        jRadioButtonSettingsInductionCertain = new javax.swing.JRadioButton();
        jRadioButtonSettingsInductionPossible = new javax.swing.JRadioButton();
        jLabelSettingsClassification = new javax.swing.JLabel();
        jRadioButtonSettingsClassificationStandard = new javax.swing.JRadioButton();
        jRadioButtonSettingsClassificationNew = new javax.swing.JRadioButton();
        jButtonRecalculate = new javax.swing.JButton();
        jLabelSettingsRuleCoalitions = new javax.swing.JLabel();
        jRadioButtonSettingsRuleCoalitionsAll = new javax.swing.JRadioButton();
        jRadioButtonSettingsRuleCoalitionsRandom = new javax.swing.JRadioButton();
        jRadioButtonSettingsRuleCoalitionsFirst = new javax.swing.JRadioButton();
        jPanelAttributes = new javax.swing.JPanel();
        jButtonSaveAttributes = new javax.swing.JButton();
        jButtonSaveAttributesAndCalculate = new javax.swing.JButton();
        jButtonAddNewAttribute = new javax.swing.JButton();
        jScrollPaneAttributes = new javax.swing.JScrollPane();
        jTableAttributes = new javax.swing.JTable();
        jPanelExamples = new javax.swing.JPanel();
        jButtonSaveExamples = new javax.swing.JButton();
        jButtonSaveExamplesAndCalculate = new javax.swing.JButton();
        jButtonAddNewExample = new javax.swing.JButton();
        jScrollPaneExamples = new javax.swing.JScrollPane();
        jTableExamples = new javax.swing.JTable();
        jPanelOutput = new javax.swing.JPanel();
        jLabelInput = new javax.swing.JLabel();
        jButtonSaveInput = new javax.swing.JButton();
        jScrollPaneInput = new javax.swing.JScrollPane();
        jTextAreaInput = new javax.swing.JTextArea();
        jLabelApprox = new javax.swing.JLabel();
        jButtonSaveApprox = new javax.swing.JButton();
        jScrollPaneApprox = new javax.swing.JScrollPane();
        jTextAreaApprox = new javax.swing.JTextArea();
        jLabelInsuffCoalitions = new javax.swing.JLabel();
        jButtonSaveInsuffCoalitions = new javax.swing.JButton();
        jScrollPaneInsuffCoalitions = new javax.swing.JScrollPane();
        jTextAreaMaxInsuffCoalitionsLowerPositive = new javax.swing.JTextArea();
        jLabelSuffCoalitions = new javax.swing.JLabel();
        jButtonSaveSuffCoalitions = new javax.swing.JButton();
        jScrollPaneSuffCoalitions = new javax.swing.JScrollPane();
        jTextAreaMinSuffCoalitionsLowerPositive = new javax.swing.JTextArea();
        jLabelMaxInsuffCoalitions = new javax.swing.JLabel();
        jButtonSaveMaxInsuffCoalitions = new javax.swing.JButton();
        jScrollPaneMaxInsuffCoalitions = new javax.swing.JScrollPane();
        jTextAreaMaxInsuffCoalitionsUpperPositive = new javax.swing.JTextArea();
        jLabelMinSuffCoalitions = new javax.swing.JLabel();
        jButtonSaveMinSuffCoalitions = new javax.swing.JButton();
        jScrollPaneMinSuffCoalitions = new javax.swing.JScrollPane();
        jTextAreaMinSuffCoalitionsUpperPositive = new javax.swing.JTextArea();
        jLabelDomlemLowerPositive = new javax.swing.JLabel();
        jButtonDomlemLowerPositive = new javax.swing.JButton();
        jScrollPaneDomlemLowerPositive = new javax.swing.JScrollPane();
        jTextAreaDomlem = new javax.swing.JTextArea();
        jButtonClassifyLowerPositive = new javax.swing.JButton();
        jRadioButtonSettingsClassificationStandard2 = new javax.swing.JRadioButton();
        jRadioButtonSettingsClassificationNew2 = new javax.swing.JRadioButton();
        jPanelClassification = new javax.swing.JPanel();
        jLabelClassificationResults = new javax.swing.JLabel();
        jScrollPaneClassification = new javax.swing.JScrollPane();
        jTextAreaClassification = new javax.swing.JTextArea();
        jButtonSaveClassification = new javax.swing.JButton();
        jScrollPaneRules = new javax.swing.JScrollPane();
        jTextAreaRules = new javax.swing.JTextArea();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextAreaClassificationLog = new javax.swing.JTextArea();
        jLabelClassificationRules = new javax.swing.JLabel();
        jLabelClassificationLogs = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("DBRSAaORC");
        setResizable(false);

        jButtonOpenFile.setText("Open a file and calculate");
        jButtonOpenFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonOpenFileActionPerformed(evt);
            }
        });

        jTextAreaLogs.setEditable(false);
        jTextAreaLogs.setColumns(20);
        jTextAreaLogs.setLineWrap(true);
        jTextAreaLogs.setRows(5);
        jTextAreaLogs.setDisabledTextColor(new java.awt.Color(0, 0, 0));
        jScrollPaneLogs.setViewportView(jTextAreaLogs);

        jPanelSettings.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jLabelSettings.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jLabelSettings.setText("Settings");

        jLabelSettingsOutranking.setText("Outranking relation:");

        jRadioButtonSettingsOutrankingAll.setText("common outranking relation for all class unions");
        jRadioButtonSettingsOutrankingAll.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonSettingsOutrankingAllActionPerformed(evt);
            }
        });

        jRadioButtonSettingsOutrankingIndividual.setText("outranking relation for the individual class unions");

        jLabelSettingsCoalitions.setText("Coalitions of criteria:");

        jRadioButtonSettingsCoalitionsNonOutranking.setText("coalitions of criteria derived from non-outranking relation");

        jRadioButtonSettingsCoalitionsPreference.setText("coalitions of criteria derived from preference relation");

        jLabelSettingsInduction.setText("Induction and classification:");

        jRadioButtonSettingsInductionCertain.setText("certain rules");

        jRadioButtonSettingsInductionPossible.setText("possible rules");

        jLabelSettingsClassification.setText("Classification algorithm:");

        jRadioButtonSettingsClassificationStandard.setText("standard classification algorithm");
        jRadioButtonSettingsClassificationStandard.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonSettingsClassificationStandardActionPerformed(evt);
            }
        });

        jRadioButtonSettingsClassificationNew.setText("new classification algorithm");
        jRadioButtonSettingsClassificationNew.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonSettingsClassificationNewActionPerformed(evt);
            }
        });

        jButtonRecalculate.setText("Recalculate");
        jButtonRecalculate.setEnabled(false);
        jButtonRecalculate.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonRecalculateActionPerformed(evt);
            }
        });

        jLabelSettingsRuleCoalitions.setText("Rules from coalitions");

        jRadioButtonSettingsRuleCoalitionsAll.setText("all");
        jRadioButtonSettingsRuleCoalitionsAll.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonSettingsRuleCoalitionsAllActionPerformed(evt);
            }
        });

        jRadioButtonSettingsRuleCoalitionsRandom.setText("one random");

        jRadioButtonSettingsRuleCoalitionsFirst.setText("only first");

        javax.swing.GroupLayout jPanelSettingsLayout = new javax.swing.GroupLayout(jPanelSettings);
        jPanelSettings.setLayout(jPanelSettingsLayout);
        jPanelSettingsLayout.setHorizontalGroup(
            jPanelSettingsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelSettingsLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelSettingsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jButtonRecalculate, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(jPanelSettingsLayout.createSequentialGroup()
                        .addGroup(jPanelSettingsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabelSettings)
                            .addGroup(jPanelSettingsLayout.createSequentialGroup()
                                .addGroup(jPanelSettingsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabelSettingsOutranking)
                                    .addComponent(jLabelSettingsCoalitions)
                                    .addComponent(jLabelSettingsRuleCoalitions)
                                    .addComponent(jLabelSettingsInduction)
                                    .addComponent(jLabelSettingsClassification))
                                .addGap(6, 6, 6)
                                .addGroup(jPanelSettingsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jRadioButtonSettingsCoalitionsNonOutranking)
                                    .addComponent(jRadioButtonSettingsCoalitionsPreference)
                                    .addComponent(jRadioButtonSettingsOutrankingAll)
                                    .addComponent(jRadioButtonSettingsOutrankingIndividual)
                                    .addComponent(jRadioButtonSettingsRuleCoalitionsFirst)
                                    .addComponent(jRadioButtonSettingsRuleCoalitionsRandom)
                                    .addComponent(jRadioButtonSettingsRuleCoalitionsAll)
                                    .addComponent(jRadioButtonSettingsInductionCertain)
                                    .addComponent(jRadioButtonSettingsInductionPossible)
                                    .addComponent(jRadioButtonSettingsClassificationStandard)
                                    .addComponent(jRadioButtonSettingsClassificationNew))))
                        .addGap(0, 311, Short.MAX_VALUE)))
                .addContainerGap())
        );
        jPanelSettingsLayout.setVerticalGroup(
            jPanelSettingsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelSettingsLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabelSettings)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanelSettingsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabelSettingsOutranking)
                    .addComponent(jRadioButtonSettingsOutrankingIndividual))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jRadioButtonSettingsOutrankingAll)
                .addGap(18, 18, 18)
                .addGroup(jPanelSettingsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jRadioButtonSettingsCoalitionsNonOutranking)
                    .addComponent(jLabelSettingsCoalitions))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jRadioButtonSettingsCoalitionsPreference)
                .addGap(18, 18, 18)
                .addGroup(jPanelSettingsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabelSettingsRuleCoalitions)
                    .addGroup(jPanelSettingsLayout.createSequentialGroup()
                        .addComponent(jRadioButtonSettingsRuleCoalitionsFirst)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButtonSettingsRuleCoalitionsRandom)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButtonSettingsRuleCoalitionsAll)))
                .addGap(18, 18, 18)
                .addGroup(jPanelSettingsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jRadioButtonSettingsInductionPossible)
                    .addComponent(jLabelSettingsInduction))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jRadioButtonSettingsInductionCertain)
                .addGap(18, 18, 18)
                .addGroup(jPanelSettingsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jRadioButtonSettingsClassificationStandard)
                    .addComponent(jLabelSettingsClassification))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jRadioButtonSettingsClassificationNew)
                .addGap(18, 18, 18)
                .addComponent(jButtonRecalculate)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout jPanelInputLayout = new javax.swing.GroupLayout(jPanelInput);
        jPanelInput.setLayout(jPanelInputLayout);
        jPanelInputLayout.setHorizontalGroup(
            jPanelInputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelInputLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelInputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jButtonOpenFile, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(jPanelInputLayout.createSequentialGroup()
                        .addComponent(jScrollPaneLogs, javax.swing.GroupLayout.PREFERRED_SIZE, 778, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jPanelSettings, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addContainerGap())
        );
        jPanelInputLayout.setVerticalGroup(
            jPanelInputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelInputLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jButtonOpenFile, javax.swing.GroupLayout.PREFERRED_SIZE, 52, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanelInputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPaneLogs, javax.swing.GroupLayout.DEFAULT_SIZE, 698, Short.MAX_VALUE)
                    .addGroup(jPanelInputLayout.createSequentialGroup()
                        .addComponent(jPanelSettings, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addContainerGap())
        );

        jTabbedPaneExamples.addTab("Input", jPanelInput);

        jButtonSaveAttributes.setText("Save");
        jButtonSaveAttributes.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSaveAttributesActionPerformed(evt);
            }
        });

        jButtonSaveAttributesAndCalculate.setText("Save & Calculate");
        jButtonSaveAttributesAndCalculate.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSaveAttributesAndCalculateActionPerformed(evt);
            }
        });

        jButtonAddNewAttribute.setText("Add new attribute");
        jButtonAddNewAttribute.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonAddNewAttributeActionPerformed(evt);
            }
        });

        jTableAttributes.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPaneAttributes.setViewportView(jTableAttributes);

        javax.swing.GroupLayout jPanelAttributesLayout = new javax.swing.GroupLayout(jPanelAttributes);
        jPanelAttributes.setLayout(jPanelAttributesLayout);
        jPanelAttributesLayout.setHorizontalGroup(
            jPanelAttributesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelAttributesLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelAttributesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanelAttributesLayout.createSequentialGroup()
                        .addComponent(jButtonSaveAttributes, javax.swing.GroupLayout.PREFERRED_SIZE, 486, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButtonSaveAttributesAndCalculate, javax.swing.GroupLayout.DEFAULT_SIZE, 1063, Short.MAX_VALUE))
                    .addComponent(jButtonAddNewAttribute, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jScrollPaneAttributes))
                .addContainerGap())
        );
        jPanelAttributesLayout.setVerticalGroup(
            jPanelAttributesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelAttributesLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelAttributesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jButtonSaveAttributes, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jButtonSaveAttributesAndCalculate, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButtonAddNewAttribute)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPaneAttributes, javax.swing.GroupLayout.DEFAULT_SIZE, 698, Short.MAX_VALUE)
                .addContainerGap())
        );

        jTabbedPaneExamples.addTab("Attributes", jPanelAttributes);

        jButtonSaveExamples.setText("Save");
        jButtonSaveExamples.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSaveExamplesActionPerformed(evt);
            }
        });

        jButtonSaveExamplesAndCalculate.setText("Save & Calculate");
        jButtonSaveExamplesAndCalculate.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSaveExamplesAndCalculateActionPerformed(evt);
            }
        });

        jButtonAddNewExample.setText("Add new example");
        jButtonAddNewExample.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonAddNewExampleActionPerformed(evt);
            }
        });

        jTableExamples.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPaneExamples.setViewportView(jTableExamples);

        javax.swing.GroupLayout jPanelExamplesLayout = new javax.swing.GroupLayout(jPanelExamples);
        jPanelExamples.setLayout(jPanelExamplesLayout);
        jPanelExamplesLayout.setHorizontalGroup(
            jPanelExamplesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelExamplesLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelExamplesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPaneExamples)
                    .addComponent(jButtonAddNewExample, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanelExamplesLayout.createSequentialGroup()
                        .addComponent(jButtonSaveExamples, javax.swing.GroupLayout.PREFERRED_SIZE, 486, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButtonSaveExamplesAndCalculate, javax.swing.GroupLayout.DEFAULT_SIZE, 1063, Short.MAX_VALUE)))
                .addContainerGap())
        );
        jPanelExamplesLayout.setVerticalGroup(
            jPanelExamplesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelExamplesLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelExamplesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jButtonSaveExamples, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jButtonSaveExamplesAndCalculate, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButtonAddNewExample)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPaneExamples, javax.swing.GroupLayout.DEFAULT_SIZE, 698, Short.MAX_VALUE)
                .addContainerGap())
        );

        jTabbedPaneExamples.addTab("Examples", jPanelExamples);

        jLabelInput.setText("Input");

        jButtonSaveInput.setText("Save input to a file");
        jButtonSaveInput.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSaveInputActionPerformed(evt);
            }
        });

        jTextAreaInput.setEditable(false);
        jTextAreaInput.setColumns(20);
        jTextAreaInput.setRows(5);
        jTextAreaInput.setDisabledTextColor(new java.awt.Color(0, 0, 0));
        jScrollPaneInput.setViewportView(jTextAreaInput);

        jLabelApprox.setText("Approximations of classes unions");

        jButtonSaveApprox.setText("Save approximations to a file");
        jButtonSaveApprox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSaveApproxActionPerformed(evt);
            }
        });

        jTextAreaApprox.setEditable(false);
        jTextAreaApprox.setColumns(20);
        jTextAreaApprox.setLineWrap(true);
        jTextAreaApprox.setRows(5);
        jTextAreaApprox.setDisabledTextColor(new java.awt.Color(0, 0, 0));
        jScrollPaneApprox.setViewportView(jTextAreaApprox);

        jLabelInsuffCoalitions.setText("Maximum insufficient coalitions of lower approximation of positive unions");

        jButtonSaveInsuffCoalitions.setText("Save coalitions to a file");
        jButtonSaveInsuffCoalitions.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSaveInsuffCoalitionsActionPerformed(evt);
            }
        });

        jTextAreaMaxInsuffCoalitionsLowerPositive.setEditable(false);
        jTextAreaMaxInsuffCoalitionsLowerPositive.setColumns(20);
        jTextAreaMaxInsuffCoalitionsLowerPositive.setLineWrap(true);
        jTextAreaMaxInsuffCoalitionsLowerPositive.setRows(5);
        jTextAreaMaxInsuffCoalitionsLowerPositive.setDisabledTextColor(new java.awt.Color(0, 0, 0));
        jScrollPaneInsuffCoalitions.setViewportView(jTextAreaMaxInsuffCoalitionsLowerPositive);

        jLabelSuffCoalitions.setText("Minimum sufficient coalitions of lower approximation of positive unions");

        jButtonSaveSuffCoalitions.setText("Save coalitions to a file");
        jButtonSaveSuffCoalitions.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSaveSuffCoalitionsActionPerformed(evt);
            }
        });

        jTextAreaMinSuffCoalitionsLowerPositive.setEditable(false);
        jTextAreaMinSuffCoalitionsLowerPositive.setColumns(20);
        jTextAreaMinSuffCoalitionsLowerPositive.setLineWrap(true);
        jTextAreaMinSuffCoalitionsLowerPositive.setRows(5);
        jTextAreaMinSuffCoalitionsLowerPositive.setDisabledTextColor(new java.awt.Color(0, 0, 0));
        jScrollPaneSuffCoalitions.setViewportView(jTextAreaMinSuffCoalitionsLowerPositive);

        jLabelMaxInsuffCoalitions.setText("Maximum insufficient coalitions of upper approximation of positive unions");

        jButtonSaveMaxInsuffCoalitions.setText("Save coalitions to a file");
        jButtonSaveMaxInsuffCoalitions.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSaveMaxInsuffCoalitionsActionPerformed(evt);
            }
        });

        jTextAreaMaxInsuffCoalitionsUpperPositive.setEditable(false);
        jTextAreaMaxInsuffCoalitionsUpperPositive.setColumns(20);
        jTextAreaMaxInsuffCoalitionsUpperPositive.setLineWrap(true);
        jTextAreaMaxInsuffCoalitionsUpperPositive.setRows(5);
        jTextAreaMaxInsuffCoalitionsUpperPositive.setDisabledTextColor(new java.awt.Color(0, 0, 0));
        jScrollPaneMaxInsuffCoalitions.setViewportView(jTextAreaMaxInsuffCoalitionsUpperPositive);

        jLabelMinSuffCoalitions.setText("Minimum sufficient coalitions of upper approximation of positive unions");

        jButtonSaveMinSuffCoalitions.setText("Save coalitions to a file");
        jButtonSaveMinSuffCoalitions.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSaveMinSuffCoalitionsActionPerformed(evt);
            }
        });

        jTextAreaMinSuffCoalitionsUpperPositive.setEditable(false);
        jTextAreaMinSuffCoalitionsUpperPositive.setColumns(20);
        jTextAreaMinSuffCoalitionsUpperPositive.setLineWrap(true);
        jTextAreaMinSuffCoalitionsUpperPositive.setRows(5);
        jTextAreaMinSuffCoalitionsUpperPositive.setDisabledTextColor(new java.awt.Color(0, 0, 0));
        jScrollPaneMinSuffCoalitions.setViewportView(jTextAreaMinSuffCoalitionsUpperPositive);

        jLabelDomlemLowerPositive.setText("Domlem rules");

        jButtonDomlemLowerPositive.setText("Save rules to a file");
        jButtonDomlemLowerPositive.setMaximumSize(new java.awt.Dimension(171, 23));
        jButtonDomlemLowerPositive.setMinimumSize(new java.awt.Dimension(171, 23));
        jButtonDomlemLowerPositive.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonDomlemLowerPositiveActionPerformed(evt);
            }
        });

        jTextAreaDomlem.setEditable(false);
        jTextAreaDomlem.setColumns(20);
        jTextAreaDomlem.setLineWrap(true);
        jTextAreaDomlem.setRows(5);
        jTextAreaDomlem.setDisabledTextColor(new java.awt.Color(0, 0, 0));
        jScrollPaneDomlemLowerPositive.setViewportView(jTextAreaDomlem);

        jButtonClassifyLowerPositive.setText("Classify");
        jButtonClassifyLowerPositive.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonClassifyLowerPositiveActionPerformed(evt);
            }
        });

        jRadioButtonSettingsClassificationStandard2.setText("standard classification algorithm");
        jRadioButtonSettingsClassificationStandard2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonSettingsClassificationStandard2ActionPerformed(evt);
            }
        });

        jRadioButtonSettingsClassificationNew2.setText("new classification algorithm");
        jRadioButtonSettingsClassificationNew2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonSettingsClassificationNew2ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanelOutputLayout = new javax.swing.GroupLayout(jPanelOutput);
        jPanelOutput.setLayout(jPanelOutputLayout);
        jPanelOutputLayout.setHorizontalGroup(
            jPanelOutputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelOutputLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelOutputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(jPanelOutputLayout.createSequentialGroup()
                        .addComponent(jLabelInput, javax.swing.GroupLayout.PREFERRED_SIZE, 173, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButtonSaveInput, javax.swing.GroupLayout.PREFERRED_SIZE, 200, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jScrollPaneInput))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanelOutputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanelOutputLayout.createSequentialGroup()
                        .addComponent(jLabelMinSuffCoalitions, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButtonSaveMinSuffCoalitions, javax.swing.GroupLayout.PREFERRED_SIZE, 200, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jScrollPaneMaxInsuffCoalitions, javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanelOutputLayout.createSequentialGroup()
                        .addComponent(jLabelMaxInsuffCoalitions, javax.swing.GroupLayout.DEFAULT_SIZE, 440, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButtonSaveMaxInsuffCoalitions, javax.swing.GroupLayout.PREFERRED_SIZE, 200, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jScrollPaneSuffCoalitions, javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanelOutputLayout.createSequentialGroup()
                        .addComponent(jLabelSuffCoalitions, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButtonSaveSuffCoalitions, javax.swing.GroupLayout.PREFERRED_SIZE, 200, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jScrollPaneInsuffCoalitions, javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanelOutputLayout.createSequentialGroup()
                        .addComponent(jLabelInsuffCoalitions, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButtonSaveInsuffCoalitions, javax.swing.GroupLayout.PREFERRED_SIZE, 200, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanelOutputLayout.createSequentialGroup()
                        .addComponent(jLabelApprox, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButtonSaveApprox, javax.swing.GroupLayout.PREFERRED_SIZE, 200, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jScrollPaneApprox)
                    .addComponent(jScrollPaneMinSuffCoalitions))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanelOutputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanelOutputLayout.createSequentialGroup()
                        .addComponent(jLabelDomlemLowerPositive, javax.swing.GroupLayout.PREFERRED_SIZE, 228, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jButtonDomlemLowerPositive, javax.swing.GroupLayout.PREFERRED_SIZE, 183, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanelOutputLayout.createSequentialGroup()
                        .addComponent(jScrollPaneDomlemLowerPositive, javax.swing.GroupLayout.PREFERRED_SIZE, 522, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(jPanelOutputLayout.createSequentialGroup()
                        .addGap(0, 0, Short.MAX_VALUE)
                        .addComponent(jRadioButtonSettingsClassificationStandard2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButtonSettingsClassificationNew2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButtonClassifyLowerPositive, javax.swing.GroupLayout.PREFERRED_SIZE, 183, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        jPanelOutputLayout.setVerticalGroup(
            jPanelOutputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelOutputLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelOutputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanelOutputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addGroup(jPanelOutputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabelApprox, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jButtonSaveApprox, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addGroup(jPanelOutputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabelInput, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jButtonSaveInput, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                    .addComponent(jLabelDomlemLowerPositive, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButtonDomlemLowerPositive, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanelOutputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPaneInput)
                    .addGroup(jPanelOutputLayout.createSequentialGroup()
                        .addComponent(jScrollPaneApprox, javax.swing.GroupLayout.PREFERRED_SIZE, 197, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(6, 6, 6)
                        .addGroup(jPanelOutputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabelInsuffCoalitions, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jButtonSaveInsuffCoalitions, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPaneInsuffCoalitions, javax.swing.GroupLayout.PREFERRED_SIZE, 90, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanelOutputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabelSuffCoalitions, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jButtonSaveSuffCoalitions, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPaneSuffCoalitions, javax.swing.GroupLayout.PREFERRED_SIZE, 90, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanelOutputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabelMaxInsuffCoalitions, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jButtonSaveMaxInsuffCoalitions, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPaneMaxInsuffCoalitions, javax.swing.GroupLayout.PREFERRED_SIZE, 90, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanelOutputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabelMinSuffCoalitions, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jButtonSaveMinSuffCoalitions, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPaneMinSuffCoalitions, javax.swing.GroupLayout.PREFERRED_SIZE, 119, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanelOutputLayout.createSequentialGroup()
                        .addGap(0, 0, Short.MAX_VALUE)
                        .addGroup(jPanelOutputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jButtonClassifyLowerPositive)
                            .addComponent(jRadioButtonSettingsClassificationStandard2)
                            .addComponent(jRadioButtonSettingsClassificationNew2))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPaneDomlemLowerPositive, javax.swing.GroupLayout.PREFERRED_SIZE, 698, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );

        jTabbedPaneExamples.addTab("Output", jPanelOutput);

        jLabelClassificationResults.setText("Classification results");

        jTextAreaClassification.setEditable(false);
        jTextAreaClassification.setColumns(20);
        jTextAreaClassification.setRows(5);
        jScrollPaneClassification.setViewportView(jTextAreaClassification);

        jButtonSaveClassification.setText("Save classification to a file");
        jButtonSaveClassification.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSaveClassificationActionPerformed(evt);
            }
        });

        jTextAreaRules.setEditable(false);
        jTextAreaRules.setColumns(20);
        jTextAreaRules.setRows(5);
        jScrollPaneRules.setViewportView(jTextAreaRules);

        jTextAreaClassificationLog.setEditable(false);
        jTextAreaClassificationLog.setColumns(20);
        jTextAreaClassificationLog.setRows(5);
        jScrollPane1.setViewportView(jTextAreaClassificationLog);

        jLabelClassificationRules.setText("Rules");

        jLabelClassificationLogs.setText("Logs");

        javax.swing.GroupLayout jPanelClassificationLayout = new javax.swing.GroupLayout(jPanelClassification);
        jPanelClassification.setLayout(jPanelClassificationLayout);
        jPanelClassificationLayout.setHorizontalGroup(
            jPanelClassificationLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanelClassificationLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelClassificationLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jScrollPaneRules, javax.swing.GroupLayout.DEFAULT_SIZE, 502, Short.MAX_VALUE)
                    .addComponent(jLabelClassificationRules, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanelClassificationLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanelClassificationLayout.createSequentialGroup()
                        .addComponent(jLabelClassificationResults, javax.swing.GroupLayout.PREFERRED_SIZE, 775, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButtonSaveClassification, javax.swing.GroupLayout.DEFAULT_SIZE, 268, Short.MAX_VALUE))
                    .addComponent(jScrollPaneClassification)
                    .addComponent(jScrollPane1)
                    .addGroup(jPanelClassificationLayout.createSequentialGroup()
                        .addComponent(jLabelClassificationLogs)
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addContainerGap())
        );
        jPanelClassificationLayout.setVerticalGroup(
            jPanelClassificationLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelClassificationLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelClassificationLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabelClassificationResults)
                    .addComponent(jButtonSaveClassification)
                    .addComponent(jLabelClassificationRules))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanelClassificationLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPaneRules, javax.swing.GroupLayout.DEFAULT_SIZE, 727, Short.MAX_VALUE)
                    .addGroup(jPanelClassificationLayout.createSequentialGroup()
                        .addComponent(jScrollPaneClassification, javax.swing.GroupLayout.PREFERRED_SIZE, 342, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabelClassificationLogs)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPane1)))
                .addContainerGap())
        );

        jTabbedPaneExamples.addTab("Classification", jPanelClassification);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPaneExamples)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPaneExamples)
                .addContainerGap())
        );

        jTabbedPaneExamples.getAccessibleContext().setAccessibleName("tab3");

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonOpenFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonOpenFileActionPerformed
        dbModel = loadIsf();
        if (dbModel != null) {
            initTableAttributes(dbModel.getAttributes());
            initTableExamples(dbModel.getAttributes(), dbModel.getExamples());
            calculateAll();
        }
    }//GEN-LAST:event_jButtonOpenFileActionPerformed

    private void jButtonSaveAttributesAndCalculateActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSaveAttributesAndCalculateActionPerformed
        saveTableAttributes();
        if (dbModel != null) {
            calculateAll();
        }
    }//GEN-LAST:event_jButtonSaveAttributesAndCalculateActionPerformed

    private void jButtonSaveExamplesAndCalculateActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSaveExamplesAndCalculateActionPerformed
        saveTableExamples();
        if (dbModel != null) {
            calculateAll();
        }
    }//GEN-LAST:event_jButtonSaveExamplesAndCalculateActionPerformed

    private void jButtonAddNewExampleActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAddNewExampleActionPerformed
        DefaultTableModel model = (DefaultTableModel) jTableExamples.getModel();
        model.addRow(new Object[dbModel.getAttributes().size()]);
    }//GEN-LAST:event_jButtonAddNewExampleActionPerformed

    private void jButtonAddNewAttributeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAddNewAttributeActionPerformed
        DefaultTableModel model = (DefaultTableModel) jTableAttributes.getModel();
        model.addRow(new Object[]{null, null, null, null});
    }//GEN-LAST:event_jButtonAddNewAttributeActionPerformed

    private void jButtonSaveAttributesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSaveAttributesActionPerformed
        saveTableAttributes();
        initTableExamples(dbModel.getAttributes(), dbModel.getExamples());
    }//GEN-LAST:event_jButtonSaveAttributesActionPerformed

    private void jButtonSaveExamplesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSaveExamplesActionPerformed
        saveTableExamples();
    }//GEN-LAST:event_jButtonSaveExamplesActionPerformed

    private void jButtonSaveInputActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSaveInputActionPerformed
        saveToFile(jTextAreaInput.getText());
    }//GEN-LAST:event_jButtonSaveInputActionPerformed

    private void jButtonSaveApproxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSaveApproxActionPerformed
        saveToFile(jTextAreaApprox.getText());
    }//GEN-LAST:event_jButtonSaveApproxActionPerformed

    private void jButtonSaveInsuffCoalitionsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSaveInsuffCoalitionsActionPerformed
        saveToFile(jTextAreaMaxInsuffCoalitionsLowerPositive.getText());
    }//GEN-LAST:event_jButtonSaveInsuffCoalitionsActionPerformed

    private void jButtonSaveMinSuffCoalitionsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSaveMinSuffCoalitionsActionPerformed
        saveToFile(jTextAreaMinSuffCoalitionsUpperPositive.getText());
    }//GEN-LAST:event_jButtonSaveMinSuffCoalitionsActionPerformed

    private void jButtonSaveMaxInsuffCoalitionsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSaveMaxInsuffCoalitionsActionPerformed
        saveToFile(jTextAreaMaxInsuffCoalitionsUpperPositive.getText());
    }//GEN-LAST:event_jButtonSaveMaxInsuffCoalitionsActionPerformed

    private void jButtonSaveSuffCoalitionsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSaveSuffCoalitionsActionPerformed
        saveToFile(jTextAreaMinSuffCoalitionsLowerPositive.getText());
    }//GEN-LAST:event_jButtonSaveSuffCoalitionsActionPerformed

    private void jButtonDomlemLowerPositiveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonDomlemLowerPositiveActionPerformed
        saveToFile(jTextAreaDomlem.getText());
    }//GEN-LAST:event_jButtonDomlemLowerPositiveActionPerformed

    private void jButtonClassifyLowerPositiveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonClassifyLowerPositiveActionPerformed
        classifyAll();
    }//GEN-LAST:event_jButtonClassifyLowerPositiveActionPerformed

    private void jButtonSaveClassificationActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSaveClassificationActionPerformed
        saveToFile(jTextAreaClassification.getText());
    }//GEN-LAST:event_jButtonSaveClassificationActionPerformed

    private void jRadioButtonSettingsOutrankingAllActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonSettingsOutrankingAllActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jRadioButtonSettingsOutrankingAllActionPerformed

    private void jRadioButtonSettingsClassificationNewActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonSettingsClassificationNewActionPerformed
        jRadioButtonSettingsClassificationNew2.setSelected(true);
    }//GEN-LAST:event_jRadioButtonSettingsClassificationNewActionPerformed

    private void jButtonRecalculateActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonRecalculateActionPerformed
        if (dbModel != null) {
            calculateAll();
        }
    }//GEN-LAST:event_jButtonRecalculateActionPerformed

    private void jRadioButtonSettingsClassificationStandardActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonSettingsClassificationStandardActionPerformed
        jRadioButtonSettingsClassificationStandard2.setSelected(true);
    }//GEN-LAST:event_jRadioButtonSettingsClassificationStandardActionPerformed

    private void jRadioButtonSettingsClassificationStandard2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonSettingsClassificationStandard2ActionPerformed
        jRadioButtonSettingsClassificationStandard.setSelected(true);
    }//GEN-LAST:event_jRadioButtonSettingsClassificationStandard2ActionPerformed

    private void jRadioButtonSettingsClassificationNew2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonSettingsClassificationNew2ActionPerformed
        jRadioButtonSettingsClassificationNew.setSelected(true);
    }//GEN-LAST:event_jRadioButtonSettingsClassificationNew2ActionPerformed

    private void jRadioButtonSettingsRuleCoalitionsAllActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonSettingsRuleCoalitionsAllActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jRadioButtonSettingsRuleCoalitionsAllActionPerformed

    private ISF loadIsf() {
        ISF resultIsf;
        final JFileChooser fc = new JFileChooser();
        FileNameExtensionFilter filter = new FileNameExtensionFilter("ISF files", "isf");
        fc.setFileFilter(filter);
        fc.setCurrentDirectory(new File("."));
        //In response to a button click:
        int returnVal = fc.showOpenDialog(jPanelInput);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            try {
                resultIsf = new ISF(fc.getSelectedFile().getPath());
                System.out.println(String.format("File: %s", fc.getSelectedFile().getPath()));
                logMessage(String.format("File %s has been read.", fc.getSelectedFile().getPath()));
            } catch (IOException ex) {
                Logger.getLogger(DbrsaaorcJFrame.class.getName()).log(Level.SEVERE, null, ex);
                logMessage(ex.getMessage());
                jTextAreaInput.setText("");
                resultIsf = null;
            }
        } else {
            logMessage("Open file canceled (" + Integer.toString(returnVal) + ").");
            jTextAreaInput.setText("");
            resultIsf = null;
        }
        return resultIsf;
    }

    private void saveToFile(String text) {
        final JFileChooser fc = new JFileChooser();
        fc.setCurrentDirectory(new File("."));
        //In response to a button click:
        int returnVal = fc.showSaveDialog(jPanelInput);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            try (PrintWriter out = new PrintWriter(fc.getSelectedFile().getPath())) {
                out.println(text);
                logMessage(String.format("File %s has been saved.", fc.getSelectedFile().getPath()));
            } catch (FileNotFoundException ex) {
                System.err.println(ex.getMessage());
            }
        } else {
            logMessage("Save file canceled (" + Integer.toString(returnVal) + ").");
            dbModel = null;
        }
    }

    private void initTableAttributes(List<Attribute> attributes) {
        Object[][] tableAttributes = new Object[attributes.size()][4];
        for (int i = 0; i < attributes.size(); ++i) {
            tableAttributes[i][0] = attributes.get(i).getName();
            AttributeType attributeType = attributes.get(i).getType();
            String attributeValues = attributes.get(i).getValues().toString();
            switch (attributeType) {
                case CONTINUOUS:
                    attributeValues = "(continuous)";
                    break;
                case NUMBERCODED:
                    attributeValues = "(numbercoded)";
                    break;
                case OMIT:
                    attributeValues = "(omit)";
                    break;
                case ORDEREDLIST:
                    attributeValues = attributeValues.replace("[", "<");
                    attributeValues = attributeValues.replace("]", ">");
                    break;
                default:
            }
            tableAttributes[i][1] = attributeValues;
            tableAttributes[i][2] = attributes.get(i).isDecision();
        }
        String[] tableColumns = new String[]{"Name", "Values", "Dec"};
        DefaultTableModel model = new DefaultTableModel(tableAttributes, tableColumns);
        jTableAttributes = new JTable(model) {
            @Override
            public Class getColumnClass(int column) {
                switch (column) {
                    case 2:
                        return Boolean.class;
                    default:
                        return String.class;
                }
            }
        };
        final int width = 35;
        jTableAttributes.getColumnModel().getColumn(2).setPreferredWidth(width);
        jTableAttributes.getColumnModel().getColumn(2).setMinWidth(width);
        jTableAttributes.getColumnModel().getColumn(2).setWidth(width);
        jTableAttributes.getColumnModel().getColumn(2).setMaxWidth(width);
        jTableAttributes.getColumnModel().getColumn(2).setResizable(false);
        jScrollPaneAttributes.setViewportView(jTableAttributes);
    }

    private void initTableExamples(List<Attribute> attributes, List<Example> examples) {
        Object[][] tableExamples = new Object[examples.size()][attributes.size()];
        for (int i = 0; i < examples.size(); ++i) {
            for (int j = 0; j < attributes.size(); ++j) {
                try {
                    tableExamples[i][j] = examples.get(i).getAttributeValue(j);
                } catch (IndexOutOfBoundsException ex) {
                    System.err.println(ex.getMessage());
                }
            }
        }
        List<String> tableAttributes = new ArrayList<>();
        for (Attribute attr : attributes) {
            tableAttributes.add(attr.getName());
        }
        DefaultTableModel model = new DefaultTableModel(tableExamples, tableAttributes.toArray());
        jTableExamples.setModel(model);
    }

    private void clearOutput() {
        jTextAreaApprox.setText("");
        jTextAreaDomlem.setText("");
        jTextAreaInput.setText("");
        jTextAreaMaxInsuffCoalitionsLowerPositive.setText("");
        jTextAreaMaxInsuffCoalitionsUpperPositive.setText("");
        jTextAreaMinSuffCoalitionsLowerPositive.setText("");
        jTextAreaMinSuffCoalitionsUpperPositive.setText("");
    }

    private void saveTableAttributes() {
        DefaultTableModel model = (DefaultTableModel) jTableAttributes.getModel();
        dbModel.getAttributes().clear();
        for (int i = 0; i < model.getRowCount(); ++i) {
            String name = model.getValueAt(i, 0).toString();
            boolean decision = Boolean.valueOf(model.getValueAt(i, 2).toString());
            String attributeValues = model.getValueAt(i, 1).toString();
            Attribute attr = new Attribute(String.format("%s: %s", name, attributeValues));
            attr.setDecision(decision);
            dbModel.getAttributes().add(attr);
        }
    }

    private void saveTableExamples() {
        DefaultTableModel model = (DefaultTableModel) jTableExamples.getModel();
        dbModel.getExamples().clear();
        for (int i = 0; i < model.getRowCount(); ++i) {
            StringBuilder sb = new StringBuilder();
            for (int j = 0; j < model.getColumnCount(); ++j) {
                sb.append(model.getValueAt(i, j));
                sb.append(", ");
            }
            if (model.getColumnCount() > 0) {
                sb.delete(sb.length() - 2, sb.length());
            }
            dbModel.getExamples().add(new Example(dbModel.getAttributes(), sb.toString()));
        }
    }

    private void calculateAll() {
        try {
            clearOutput();
            jTextAreaInput.setText(dbModel.toString());

            Solver solver = new Solver(getClassification(), getCoalitions(), getInduction(), getOutranking(), getRuleCoalitions());
            sr = solver.solve(dbModel);

            /////////////////// Approximations of classes unions \\\\\\\\\\\\\\\\\\\
            StringBuilder sb = new StringBuilder();
            sb.append(sr.getLowerApproxOfNegativeClassesUnionsString());
            sb.append("\n");
            sb.append(sr.getUpperApproxOfNegativeClassesUnionsString());
            sb.append("\n");
            sb.append(sr.getLowerApproxOfPositiveClassesUnionsString());
            sb.append("\n");
            sb.append(sr.getUpperApproxOfPositiveClassesUnionsString());
            jTextAreaApprox.setText(sb.toString());

            /////////////////////////////// Coalitons \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
            jTextAreaMaxInsuffCoalitionsLowerPositive.setText(sr.getMaximiumInsufficientCoalitionsForClassLowerPositiveString(getOutranking()));
            jTextAreaMaxInsuffCoalitionsUpperPositive.setText(sr.getMaximiumInsufficientCoalitionsForClassUpperPositiveString(getOutranking()));
            jTextAreaMinSuffCoalitionsLowerPositive.setText(sr.getMinimumSufficientCoalitionsForClassLowerPositiveString(getOutranking()));
            jTextAreaMinSuffCoalitionsUpperPositive.setText(sr.getMinimumSufficientCoalitionsForClassUpperPositiveString(getOutranking()));

            /////////////////////////////// Rules \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
            sb = new StringBuilder();
            if (jRadioButtonSettingsInductionCertain.isSelected()) {
                sb.append(sr.getNegativeCertainRulesMSCLPString());
                sb.append(sr.getPositiveCertainRulesMSCUPString());
            } else {
                sb.append(sr.getNegativePossibleRulesMSCLPString());
                sb.append("\n");
                sb.append(sr.getPositivePossibleRulesMSCUPString());
            }
            jTextAreaDomlem.setText(sb.toString());

            jTabbedPaneExamples.setSelectedIndex(3);
            jButtonRecalculate.setEnabled(true);
        } catch (Exception ex) {
            logMessage("An error occured while calculating solution:");
            logMessage(ex.getMessage());
        }
    }

    private void classifyAll() {
        try {
            dbClassification = loadIsf();
            if (dbClassification != null) {
                Map<String, ListOfRules> positiveRules;
                Map<String, ListOfRules> negativeRules;
                if (getInduction() == Induction.CERTAIN) {
                    positiveRules = sr.getPositiveCertainRulesMSCUP();
                    negativeRules = sr.getNegativeCertainRulesMSCLP();
                } else {
                    positiveRules = sr.getPositivePossibleRulesMSCUP();
                    negativeRules = sr.getNegativePossibleRulesMSCLP();
                }
                Classifier classifier;
                if (getClassification() == Classification.STANDARD) {
                    classifier = new ClassifierStandard(positiveRules, negativeRules, dbClassification.getExamples());
                } else {
                    classifier = new ClassifierNew(positiveRules, negativeRules, dbModel, sr.getUpperApproxOfPositiveClassesUnions(), sr.getUpperApproxOfNegativeClassesUnions(), dbClassification.getExamples());
                }
                classifier.classify(Latex.NONE);
                jTextAreaRules.setText(classifier.getRulesString());
                jTextAreaClassification.setText(classifier.toString());
                jTextAreaClassificationLog.setText(classifier.getLog());
                jTabbedPaneExamples.setSelectedIndex(4);
            }
        } catch (Exception ex) {
            logMessage("An error occured while calculating classification:");
            logMessage(ex.getMessage());
        }
    }

    private void logMessage(String message) {
        StringBuilder sb = new StringBuilder(jTextAreaLogs.getText());
        SimpleDateFormat ft = new SimpleDateFormat("hh:mm:ss.SSSS");
        sb.append(ft.format(new Date()));
        sb.append(": ");
        sb.append(message);
        sb.append("\n");
        jTextAreaLogs.setText(sb.toString());
    }

    private Outranking getOutranking() {
        if (jRadioButtonSettingsOutrankingAll.isSelected()) {
            return Outranking.TOGETHER;
        } else {
            return Outranking.INDIVIDUAL;
        }
    }

    private Coalitions getCoalitions() {
        if (jRadioButtonSettingsCoalitionsPreference.isSelected()) {
            return Coalitions.PREFERENCE;
        } else {
            return Coalitions.NONOUTRANKING;
        }
    }

    private Induction getInduction() {
        if (jRadioButtonSettingsInductionCertain.isSelected()) {
            return Induction.CERTAIN;
        } else {
            return Induction.POSSIBLE;
        }
    }

    private Classification getClassification() {
        if (jRadioButtonSettingsClassificationNew.isSelected()) {
            return Classification.NEW;
        } else {
            return Classification.STANDARD;
        }
    }

    private RuleCoalitions getRuleCoalitions() {
        if (jRadioButtonSettingsRuleCoalitionsAll.isSelected()) {
            return RuleCoalitions.ALL;
        } else if (jRadioButtonSettingsRuleCoalitionsFirst.isSelected()) {
            return RuleCoalitions.FIRST;
        } else {
            return RuleCoalitions.RANDOM;
        }
    }

    @Override
    public void run() {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(DbrsaaorcJFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(DbrsaaorcJFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(DbrsaaorcJFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(DbrsaaorcJFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        new DbrsaaorcJFrame().setVisible(true);
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroupSettingsClassification;
    private javax.swing.ButtonGroup buttonGroupSettingsClassification2;
    private javax.swing.ButtonGroup buttonGroupSettingsCoalitions;
    private javax.swing.ButtonGroup buttonGroupSettingsInduction;
    private javax.swing.ButtonGroup buttonGroupSettingsOutranking;
    private javax.swing.ButtonGroup buttonGroupSettingsRuleCoalitions;
    private javax.swing.JButton jButtonAddNewAttribute;
    private javax.swing.JButton jButtonAddNewExample;
    private javax.swing.JButton jButtonClassifyLowerPositive;
    private javax.swing.JButton jButtonDomlemLowerPositive;
    private javax.swing.JButton jButtonOpenFile;
    private javax.swing.JButton jButtonRecalculate;
    private javax.swing.JButton jButtonSaveApprox;
    private javax.swing.JButton jButtonSaveAttributes;
    private javax.swing.JButton jButtonSaveAttributesAndCalculate;
    private javax.swing.JButton jButtonSaveClassification;
    private javax.swing.JButton jButtonSaveExamples;
    private javax.swing.JButton jButtonSaveExamplesAndCalculate;
    private javax.swing.JButton jButtonSaveInput;
    private javax.swing.JButton jButtonSaveInsuffCoalitions;
    private javax.swing.JButton jButtonSaveMaxInsuffCoalitions;
    private javax.swing.JButton jButtonSaveMinSuffCoalitions;
    private javax.swing.JButton jButtonSaveSuffCoalitions;
    private javax.swing.JLabel jLabelApprox;
    private javax.swing.JLabel jLabelClassificationLogs;
    private javax.swing.JLabel jLabelClassificationResults;
    private javax.swing.JLabel jLabelClassificationRules;
    private javax.swing.JLabel jLabelDomlemLowerPositive;
    private javax.swing.JLabel jLabelInput;
    private javax.swing.JLabel jLabelInsuffCoalitions;
    private javax.swing.JLabel jLabelMaxInsuffCoalitions;
    private javax.swing.JLabel jLabelMinSuffCoalitions;
    private javax.swing.JLabel jLabelSettings;
    private javax.swing.JLabel jLabelSettingsClassification;
    private javax.swing.JLabel jLabelSettingsCoalitions;
    private javax.swing.JLabel jLabelSettingsInduction;
    private javax.swing.JLabel jLabelSettingsOutranking;
    private javax.swing.JLabel jLabelSettingsRuleCoalitions;
    private javax.swing.JLabel jLabelSuffCoalitions;
    private javax.swing.JPanel jPanelAttributes;
    private javax.swing.JPanel jPanelClassification;
    private javax.swing.JPanel jPanelExamples;
    private javax.swing.JPanel jPanelInput;
    private javax.swing.JPanel jPanelOutput;
    private javax.swing.JPanel jPanelSettings;
    private javax.swing.JRadioButton jRadioButtonSettingsClassificationNew;
    private javax.swing.JRadioButton jRadioButtonSettingsClassificationNew2;
    private javax.swing.JRadioButton jRadioButtonSettingsClassificationStandard;
    private javax.swing.JRadioButton jRadioButtonSettingsClassificationStandard2;
    private javax.swing.JRadioButton jRadioButtonSettingsCoalitionsNonOutranking;
    private javax.swing.JRadioButton jRadioButtonSettingsCoalitionsPreference;
    private javax.swing.JRadioButton jRadioButtonSettingsInductionCertain;
    private javax.swing.JRadioButton jRadioButtonSettingsInductionPossible;
    private javax.swing.JRadioButton jRadioButtonSettingsOutrankingAll;
    private javax.swing.JRadioButton jRadioButtonSettingsOutrankingIndividual;
    private javax.swing.JRadioButton jRadioButtonSettingsRuleCoalitionsAll;
    private javax.swing.JRadioButton jRadioButtonSettingsRuleCoalitionsFirst;
    private javax.swing.JRadioButton jRadioButtonSettingsRuleCoalitionsRandom;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPaneApprox;
    private javax.swing.JScrollPane jScrollPaneAttributes;
    private javax.swing.JScrollPane jScrollPaneClassification;
    private javax.swing.JScrollPane jScrollPaneDomlemLowerPositive;
    private javax.swing.JScrollPane jScrollPaneExamples;
    private javax.swing.JScrollPane jScrollPaneInput;
    private javax.swing.JScrollPane jScrollPaneInsuffCoalitions;
    private javax.swing.JScrollPane jScrollPaneLogs;
    private javax.swing.JScrollPane jScrollPaneMaxInsuffCoalitions;
    private javax.swing.JScrollPane jScrollPaneMinSuffCoalitions;
    private javax.swing.JScrollPane jScrollPaneRules;
    private javax.swing.JScrollPane jScrollPaneSuffCoalitions;
    private javax.swing.JTabbedPane jTabbedPaneExamples;
    private javax.swing.JTable jTableAttributes;
    private javax.swing.JTable jTableExamples;
    private javax.swing.JTextArea jTextAreaApprox;
    private javax.swing.JTextArea jTextAreaClassification;
    private javax.swing.JTextArea jTextAreaClassificationLog;
    private javax.swing.JTextArea jTextAreaDomlem;
    private javax.swing.JTextArea jTextAreaInput;
    private javax.swing.JTextArea jTextAreaLogs;
    private javax.swing.JTextArea jTextAreaMaxInsuffCoalitionsLowerPositive;
    private javax.swing.JTextArea jTextAreaMaxInsuffCoalitionsUpperPositive;
    private javax.swing.JTextArea jTextAreaMinSuffCoalitionsLowerPositive;
    private javax.swing.JTextArea jTextAreaMinSuffCoalitionsUpperPositive;
    private javax.swing.JTextArea jTextAreaRules;
    // End of variables declaration//GEN-END:variables
}
