/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package utils;

import dbrsaaorc.params.Latex;
import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 *
 * @author Mateusz Ledzianowski
 */
public class LatexHelper {

    public static String equation(String name, Latex latex) {
        if (latex != Latex.NONE) {
            return "$" + name + "$";
        } else {
            return name;
        }
    }

    public static String nameToString(String name) {
        List<String> parsedName = parse(name);
        if (parsedName.size() == 2
                && parsedName.get(0).matches("[A-Za-z]+")
                && parsedName.get(1).matches("[0-9]+")) {
            return parsedName.get(0) + "_{" + parsedName.get(1) + "}";
        }
        return name;
    }

    public static String repeat(String str, int n) {
        return new String(new char[n]).replace("\0", str);
    }

    private static List<String> parse(String str) {
        List<String> output = new ArrayList<>();
        Matcher match = Pattern.compile("[0-9]+|[A-Za-z]+").matcher(str);
        while (match.find()) {
            output.add(match.group());
        }
        return output;
    }
}
