/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package data;

import java.util.ArrayList;
import java.util.List;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author Mateusz Ledzianowski
 */
public class AttributeTest {

    private List<String> values;
    private Attribute continuousInstance;
    private Attribute numbercodedInstance;
    private Attribute orderedlistInstance;
    private Attribute unorderedlistInstance;
    private Attribute omitInstance;

    public AttributeTest() {
    }

    @BeforeClass
    public static void setUpClass() {
    }

    @AfterClass
    public static void tearDownClass() {
    }

    @Before
    public void setUp() {
        values = new ArrayList<>();
        values.add("v1");
        values.add("v2");
        values.add("v3");
        values.add("v4");
        continuousInstance = new Attribute("ca", AttributeType.CONTINUOUS);
        numbercodedInstance = new Attribute("na", AttributeType.NUMBERCODED);
        orderedlistInstance = new Attribute("oa", AttributeType.ORDEREDLIST, values);
        unorderedlistInstance = new Attribute("ua", AttributeType.UNORDEREDLIST, values);
        omitInstance = new Attribute("oa", AttributeType.OMIT);
    }

    @After
    public void tearDown() {
    }

    /**
     * Test of compareValues method, of class Attribute.
     */
    @Test
    public void testCompareValues() {
        System.out.println("compareValues");
        String value1;
        String value2;
        Integer result;
        // continuous
        value1 = Double.toString(1.0);
        value2 = Double.toString(2.5);
        result = continuousInstance.compareValues(value1, value2);
        assertTrue(result < 0);
        result = continuousInstance.compareValues(value2, value1);
        assertTrue(result > 0);
        // numbercoded
        value1 = Integer.toString(1);
        value2 = Integer.toString(4);
        result = numbercodedInstance.compareValues(value1, value2);
        assertTrue(result < 0);
        result = numbercodedInstance.compareValues(value2, value1);
        assertTrue(result > 0);
        // lists
        value1 = values.get(0);
        value2 = values.get(2);
        // orderedlist
        result = orderedlistInstance.compareValues(value1, value2);
        assertTrue(result < 0);
        result = orderedlistInstance.compareValues(value2, value1);
        assertTrue(result > 0);
        // unorderedlist
        result = unorderedlistInstance.compareValues(value1, value2);
        assertTrue(result == null);
        result = unorderedlistInstance.compareValues(value2, value1);
        assertTrue(result == null);
        // unorderedlist - decision
        unorderedlistInstance.setDecision(true);
        result = unorderedlistInstance.compareValues(value1, value2);
        assertTrue(result < 0);
        result = unorderedlistInstance.compareValues(value2, value1);
        assertTrue(result > 0);
    }

    /**
     * Test of equals method, of class Attribute.
     */
    @Test
    public void testEquals() {
        System.out.println("equals");
        assertTrue(continuousInstance.equals(continuousInstance));
        assertFalse(continuousInstance.equals(orderedlistInstance));
    }

    /**
     * Test of toString method, of class Attribute.
     */
    @Test
    public void testToString() {
        System.out.println("toString");
        String expResult = "ca: (continuous)";
        String result = continuousInstance.toString();
        assertEquals(expResult, result);
    }

    /**
     * Test of getValuePosition method, of class Attribute.
     */
    @Test
    public void testGetValuePosition() {
        System.out.println("getValuePosition");
        Integer expResult = 2;
        Integer result = orderedlistInstance.getValuePosition(values.get(expResult));
        assertEquals(expResult, result);
    }

}
