/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package data;

import java.io.IOException;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author Mateusz Ledzianowski
 */
public class ISFTest {

    public ISFTest() {
    }

    @BeforeClass
    public static void setUpClass() {
    }

    @AfterClass
    public static void tearDownClass() {
    }

    @Before
    public void setUp() {
    }

    @After
    public void tearDown() {
    }

    /**
     * Test of toString method, of class ISF.
     */
    @Test
    public void testToString() {
        System.out.println("toString");
        try {
            ISF instance = new ISF("src/resources/test.isf");
            String result = instance.toString();
            assertTrue(result.contains("**ATTRIBUTES\n"));
            assertTrue(result.contains("decision: alive\n"));
            assertTrue(result.contains("temperature: <normal,high>\n"));
            assertTrue(result.contains("alive: [YES,NO]\n"));
            assertTrue(result.contains("\n**EXAMPLES\n"));
            assertTrue(result.contains("3, 43, normal, bad, YES, 2, NO\n"));
            assertTrue(result.contains("\n**END\n"));
        } catch (IOException e) {
            System.err.println("The test dataset does not exists.");
        }
    }

    /**
     * Test of isEndedLine method, of class ISF.
     */
    @Test
    public void testIsEndedLine() {
        System.out.println("isEndedLine");
        String test0 = "6.1,3.0,4.9,1.8,Iris_viginica";
        assertTrue(ISF.isEndedLine(test0));
        String test1 = "6.1,3.0,4.9,1.8, \\";
        assertFalse(ISF.isEndedLine(test1));
        String test2 = "6.1,3.0,4.9,1.8, \\     ";
        assertFalse(ISF.isEndedLine(test2));
    }

    /**
     * Test of getClearedLine method, of class ISF.
     */
    @Test
    public void testGetClearedLine() {
        System.out.println("replaceAll");
        String test0 = "6.1,3.0,4.9,1.8,Iris_viginica";
        assertEquals(ISF.getClearedLine(test0), test0);
        String test1 = "6.1,3.0,4.9,1.8, \\\r\nIris_viginica";
        assertEquals(ISF.getClearedLine(test1), test0);
        String test2 = "6.1,3.0,4.9,1.8, \\     \r\nIris_viginica";
        assertEquals(ISF.getClearedLine(test2), test0);
    }
}
